
;===================================================================================================================================#
;~ Function Name....:  _File_List_S_Rekursiv($_Pfad_,  $_Wildc_ = '*', $_Flag_ = 0)
;
;~ Description......:  Auflistung von Dateien
;
;~ $_Pfad_..........:  Pfad
;~ $Wildc_..........:  '*' ( Standart ) Suchbegrif u. o. Wildcards bei Wildcards mit o. suchbegriff $_Flag_ auf '3' setzen es ist auch
;                      mglich mehrere suchbegriffe  zu suchen z.B  ( *wma,*mp3,*txt ) o. ( wma,mp3,txt ) getrennt mit ','
;~ $Flag............:  '0' ( Standart ) Datein u. Ordner '1' nur Datein '2' nur Ordner '3' um mit suchbegriffen zu suchen wie (*.txt)
;
;~ Return Value(s)..:  Array ( Standard )  mit den gefundenen Dateien u. o Ordner Array[0] endhlt die anzahl ( Fund )
;
;~ Author(s)........:  Kleiner27  (www.autoit.de)                                                           # 27.03.2010 09:00 #
;====================================================================================================================================#

Local $F
Local $UB
Local $FN
Local $RAS
Local $Verz
Local $Expan


Func _File_List_S_Rekursiv($Pfad, Const $Wildc = '*', Const $Flag = 0)
	$Pfad = StringRegExpReplace($Pfad, '[\\/]+\z', '\') & '\'
	If Not FileExists($Pfad) Then Return SetError(1, 1, '')
	If StringRegExp($Wildc, '[\\/:><\|]|(?s)\A\s*\z') Then Return SetError(2, 2, '')
	If Not ($Flag = 0 Or $Flag = 1 Or $Flag = 2 Or $Flag = 3) Then Return SetError(3, 3, '')
	If ($RAS <> '') Then $RAS = ''
	_Rekursiv_S_($Pfad, StringReplace(StringReplace($Wildc, '*', ''), ',', '|'), $Flag)
	If Not $RAS Then Return SetError(4, 4, '')
	Return StringSplit(StringTrimLeft($RAS, 1), '|')
EndFunc   ;==>_File_List_S_Rekursiv

Func _Rekursiv_S_($Pfad, $Wildc, $Flag)
	Local $FL
	$F = FileFindFirstFile($Pfad & '*')
	If ($F <> -1) Then
		While True
			$FN = FileFindNextFile($F)
			If @error Then ExitLoop
			$Expan = @extended
			Switch $Flag
				Case 0
					Switch $Expan
						Case 0
							$RAS &= '|' & $Pfad & $FN
						Case 1
							$FL &= '|' & $FN & '\'
							$RAS &= '|' & $Pfad & $FN
					EndSwitch
				Case 1
					Switch $Expan
						Case 0
							$RAS &= '|' & $Pfad & $FN
						Case 1
							$FL &= '|' & $FN & '\'
					EndSwitch
				Case 2
					If ($Expan = 1) Then
						$FL &= '|' & $FN & '\'
						$RAS &= '|' & $Pfad & $FN
					EndIf
				Case 3
					If ($Expan = 1) Then $FL &= '|' & $FN & '\'
					If StringRegExp($FN, $Wildc) Then $RAS &= '|' & $Pfad & $FN
			EndSwitch
		WEnd
	EndIf
	FileClose($F)
	If Not $FL Then Return $FL = '|'
	$Verz = StringSplit(StringTrimLeft($FL, 1), '|')
	$UB = UBound($Verz) - 1
	For $i = 0 To $UB - 1
		$Verz[$i] = $Verz[$i + 1]
	Next
	ReDim $Verz[$UB]
	For $For In $Verz
		If (_F_L_S_($Pfad & $For) = False) Then _Rekursiv_S_($Pfad & $For, $Wildc, $Flag)
	Next
EndFunc   ;==>_Rekursiv_S_

Func _F_L_S_($FLS)
	Dim Static $K32 = DllOpen('kernel32.dll')
	Dim $DA = DllCall($K32, 'dword', 'GetFileAttributesW', 'wstr', $FLS)
	If (@error) Then Return SetError(0, @error, 0)
	Return BitAND($DA[0], 1024) = 1024
EndFunc   ;==>_F_L_S_